---
schema_version: "1"
id: 808da5d116c4879e6d0540ec4fc4d7c0e695eb577c4d8fea516ceaff27158f3f
title: Shopper Orders
collection: developer
version: current
locale: en-us
portal_url: https://docs.salesforce.com/developer/current/en-us/commerce-cloud/commerce-api/references/generated-api-specs/shopper-orders.md
canonical_url: https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-orders
source_site: developer.salesforce.com
content_type: documentation
content_hash: 348de5d81795301fa9dc4a8762326ec2dbc0a7cb45bd03d0514e1b8b5d955c5a
products:
  - B2C Commerce API
  - Salesforce APIs
---
Shopper Orders

# Shopper Orders

[Download API specification](https://developer.salesforce.com/static/commercecloud/commerce-api/shopper-orders/shopper-orders-oas-v1-public.yaml)

## API Overview

The Shopper Orders API enables you to:

*   Create orders based on baskets prepared using the Shopper Baskets API.
*   Add a customer's payment instrument to an order.

You can choose to supply the full payment information or supply only a customer payment instrument ID and amount. If the customer payment instrument ID is set, all the other properties (except amount) are ignored and the payment data is resolved from the stored customer payment information.

**Note:** The API doesn’t allow the storage of credit card numbers. The endpoint provides the storage of masked credit card numbers only.

To update the payment status, use the Orders API.

Responses from this API are not cached because order data is transactional and unique to each shopper.

For additional guidance when working with baskets, see [Build Baskets and Place Orders](https://developer.salesforce.com/docs/commerce/commerce-api/guide/work-with-baskets-orders.html).

### Authentication & Authorization

The client requesting order information must have access to the Orders resource. The Shopper Orders API requires a shopper access token from the Shopper Login and API Access Service (SLAS).

For details on how to request a shopper access token from SLAS, see the guest user flows for [public clients](https://developer.salesforce.com/docs/commerce/commerce-api/guide/slas-public-client.html#guest-user) and [private clients](https://developer.salesforce.com/docs/commerce/commerce-api/guide/slas-private-client.html#guest-user) in the SLAS guides.

You must include `sfcc.shopper-baskets-orders` or `sfcc.shopper-baskets-orders.rw` in the client ID used to generate the SLAS token. For a full list of permissions, see the [Authorization Scopes Catalog.](https://developer.salesforce.com/docs/commerce/commerce-api/guide/auth-z-scope-catalog.html)

### Customization

#### Custom Properties

This API supports custom properties (prefixed with `c_`). For details, see [Custom Properties.](https://developer.salesforce.com/docs/commerce/commerce-api/guide/custom-properties.html)

#### Hooks

For details on working with hooks, see [Extensibility with Hooks.](https://developer.salesforce.com/docs/commerce/commerce-api/guide/extensibility_via_hooks.html)

### Response Details

#### Personalization

Responses from this API are not personalized via the Shopper Context API.

#### Caching

Responses from this API are not cached. Order data is transactional and unique to each shopper.

#### Timeouts

Shopper API requests must respond within 10 seconds, including any hook execution. If a response exceeds this threshold, an HTTP 504 status code is returned. For details, see [Timeouts and Limits.](https://developer.salesforce.com/docs/commerce/commerce-api/guide/timeouts-limits.html)

#### Error Handling

Error responses follow the [RFC 7807](https://datatracker.ietf.org/doc/html/rfc7807) problem detail format. To trace errors, include a `correlation-id` header in your request — the response returns it as `x-correlation-id`. For details, see [HTTP Status Codes and Errors.](https://developer.salesforce.com/docs/commerce/commerce-api/guide/error-response-codes.html)

### Use Cases

#### Create an Order from a Basket

Place an order by providing a basket ID. The basket must have a valid shipping address, shipping method, billing address, and payment instrument.

```sh
curl "https://{shortCode}.api.commercecloud.salesforce.com/checkout/shopper-orders/v1/organizations/{organizationId}/orders?siteId=RefArch" \
  -X POST \
  -H "Authorization: Bearer {access_token}" \
  -H "Content-Type: application/json" \
  -d '{ "basketId": "{basketId}" }'
```

### Related APIs

*   [Orders (Admin)](https://developer.salesforce.com/docs/commerce/commerce-api/references/orders?meta=Summary) — Update order status, payment status, and shipping addresses.
*   [Shopper Baskets](https://developer.salesforce.com/docs/commerce/commerce-api/references/shopper-baskets-v2?meta=Summary) — Build and manage baskets before placing an order.

**Version:** 1.22.4

## Servers

*   `https://{shortCode}.api.commercecloud.salesforce.com/checkout/shopper-orders/v1`
    *   `shortCode (default shortCode) An eight-character string assigned to a realm for routing purposes. See [Base URL and Request Formation.](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html)`

## Security

*   `ShopperToken` (oauth2) ShopperToken authentication follows the authorization code grant flow, as defined by the OAuth 2.1 standard. Depending on the type of OAuth client (public or private), this authorization flow has further requirements. For a detailed description of the authorization flow, see the [SLAS overview](https://developer.salesforce.com/docs/commerce/commerce-api/references?meta=shopper-login:Summary). A shopper token allows you to access the Shopper API endpoints of both OCAPI and the B2C Commerce API. These endpoints can be used to build headless storefronts and other applications. The `ShopperToken` security scheme is a parent of other security schemes, such as `ShopperTokenTsob`. A Shopper API endpoint can require a specific child scheme (`ShopperTokenTsob`, for example) that cannot be accessed with a regular shopper token.
    *   OAuth flow clientCredentials (tokenUrl: https://{shortCode}.api.commercecloud.salesforce.com/shopper/auth/v1/organizations/{organizationId}/oauth2/token)
    *   Scope sfcc.shopper-baskets-orders: Scope granting read-access to shopper basket or orders endpoints
    *   Scope sfcc.shopper-baskets-orders.rw: Scope granting read and write access to shopper basket or orders endpoints
    *   OAuth flow authorizationCode (authorizationUrl: https://{shortCode}.api.commercecloud.salesforce.com/shopper/auth/v1/organizations/{organizationId}/oauth2/authorize, tokenUrl: https://{shortCode}.api.commercecloud.salesforce.com/shopper/auth/v1/organizations/{organizationId}/oauth2/token, refreshUrl: https://account.demandware.com/dwsso/oauth2/access\_token)
    *   Scope sfcc.shopper-baskets-orders: Scope granting read-access to shopper basket or orders endpoints
    *   Scope sfcc.shopper-baskets-orders.rw: Scope granting read and write access to shopper basket or orders endpoints
*   `ShopperTokenTsob` (oauth2) `ShopperTokenTsob` (Tsob = trusted system on behalf) is a child of the `ShopperToken` security scheme and extends the functionality of `ShopperToken` for specific use cases. A token of type `ShopperTokenTsob` allows you to access Shopper API endpoints, including OCAPI and Salesforce Commerce API for headless applications. Besides endpoints that require this specific subtype, all other endpoints secured by the `ShopperToken` parent scheme can be accessed with a `ShopperTokenTsob`. To learn how to get a `ShopperTokenTsob` token, see [getTrustedSystemAccessToken](https://developer.salesforce.com/docs/commerce/commerce-api/references?meta=shopper-login:getTrustedSystemAccessToken).
    *   OAuth flow clientCredentials (tokenUrl: https://{shortCode}.api.commercecloud.salesforce.com/shopper/auth/v1/organizations/{organizationId}/oauth2/trusted-system/token)
    *   Scope sfcc.shopper-baskets-orders: Scope granting read-access to shopper basket or orders endpoints
    *   Scope sfcc.shopper-baskets-orders.rw: Scope granting read and write access to shopper basket or orders endpoints
*   `AmOAuth2` (oauth2) AccountManager OAuth 2.0 bearer token Authentication.
    *   OAuth flow clientCredentials (tokenUrl: https://account.demandware.com/dwsso/oauth2/access\_token)
    *   Scope sfcc.shopper-baskets-orders: Scope granting read-access to shopper basket or orders endpoints
    *   Scope sfcc.shopper-baskets-orders.rw: Scope granting read and write access to shopper basket or orders endpoints
    *   OAuth flow authorizationCode (authorizationUrl: https://account.demandware.com/dwsso/oauth2/authorize, tokenUrl: https://account.demandware.com/dwsso/oauth2/access\_token)
*   `ShopperClientContextToken` (oauth2) ShopperClientContextToken is a separate security scheme used to track and validate client context information. It is valid for Guest shoppers flows only using SLAS private clients. For registered shoppers, use existing ShopperToken flows. For authentication details, see the [SLAS overview](https://developer.salesforce.com/docs/commerce/commerce-api/references?meta=shopper-login:Summary). This token allows access to Shopper API endpoints for guest shoppers only.
    *   OAuth flow clientCredentials (tokenUrl: https://{shortCode}.api.commercecloud.salesforce.com/shopper/auth/v1/organizations/{organizationId}/oauth2/token?hint=client\_context)
    *   Scope sfcc.shopper-baskets-orders: Scope granting read-access to shopper basket or orders endpoints
    *   Scope sfcc.shopper-baskets-orders.rw: Scope granting read and write access to shopper basket or orders endpoints

## Operations

### POST Submits an order for a basket.

`POST /organizations/{organizationId}/orders`

Operation ID: `createOrder`. Security: ShopperToken (sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard); ShopperClientContextToken (sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard).

Submits an order based on a prepared basket. The only considered value from the request body is basketId.

#### Parameters

*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `locale` (query, LocaleCode) A descriptor for a geographical region by both a language and country code. By combining these two, regional differences in a language can be addressed, such as with the request header parameter `Accept-Language` following [RFC 2616](https://tools.ietf.org/html/rfc2616) & [RFC 1766](https://tools.ietf.org/html/rfc1766). This can also just refer to a language code, also RFC 2616/1766 compliant, as a default if there is no specific match for a country. Finally, can also be used to define default behavior if there is no locale specified.
    
    _Example: LanguageCountry_
    
    ```
    en-US
    ```
    
    _Example: CountryCode_
    
    ```
    US
    ```
    
*   `sfdc_usid` (header, string (uuid)) A unique shopper identifier (USID) for tracking client context. Used with endpoints secured with ShopperClientContextToken. This header is required for all endpoints secured with ShopperClientContextToken.  
    Example: `550e8400-e29b-41d4-a716-446655440000`.
*   `sfdc_dw_dnt` (header, string) Do Not Track header for privacy preferences. Used with endpoints secured with ShopperClientContextToken. If this header is not passed with endpoints secured with ShopperClientContextToken default value of 0 will be used.  
    Allowed values: `0`, `1`. Example: `1`.
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Request body

Media type: `application/json`. Schema: `Basket`.

_Example: OrderPost_

```
{
  "basketId": "a10ff320829cb0eef93ca5310a"
}
```

#### Responses

*   **200** Success, the response body contains the submitted order.
    
    Media type: `application/json`. Schema: `Order`.
    
    _Example: Order_
    
    ```
    {
      "adjustedMerchandizeTotalTax": 30,
      "adjustedShippingTotalTax": 0.8,
      "billingAddress": {
        "address1": "104 Presidential Way",
        "city": "Woburn",
        "countryCode": "US",
        "firstName": "Stephanie",
        "fullName": "Stephanie Miller",
        "id": "5f695b6f4bb63cb686483d65a0",
        "lastName": "Miller",
        "postalCode": "01801",
        "stateCode": "MA"
      },
      "channelType": "storefront",
      "confirmationStatus": "not_confirmed",
      "couponItems": [
        {
          "code": "5ties",
          "couponItemId": "d3f7ae47e5897a6b5d2fd541f0",
          "statusCode": "applied",
          "valid": true
        }
      ],
      "createdBy": "Customer",
      "creationDate": "2019-10-22T12:17:28.341Z",
      "currency": "USD",
      "customerInfo": {
        "customerId": "beQeANXJNsd0xcINsB6cSrobQa",
        "customerName": "Stephanie Miller",
        "email": "shopper@salesforce-test.com"
      },
      "customerName": "Stephanie Miller",
      "exportStatus": "not_exported",
      "groupedTaxItems": [
        {
          "taxRate": 0.05,
          "taxValue": 30.8
        }
      ],
      "guest": true,
      "giftCertificateItems": [
        {
          "amount": 1,
          "giftCertificateItemId": "540db3ffe58bfb04ab673757d7",
          "recipientEmail": "miller@salesforce-test.com",
          "shipmentId": "me"
        }
      ],
      "lastModified": "2019-10-22T12:17:28.376Z",
      "merchandizeTotalTax": 30,
      "orderNo": "00000410",
      "orderPriceAdjustments": [
        {
          "appliedDiscount": {
            "amount": 10,
            "type": "amount"
          },
          "reasonCode": "customer service",
          "createdBy": "support",
          "creationDate": "2019-10-22T12:17:28.347Z",
          "custom": true,
          "lastModified": "2019-10-22T12:17:28.349Z",
          "manual": true,
          "price": -10,
          "priceAdjustmentId": "63b9eb9b4a92bd3e5c6ee804c2",
          "promotionId": "5ties"
        }
      ],
      "orderToken": "7gJDIFlnho_mXrxfxVB9Neic3J7szzR9glvgU5Ath-I",
      "orderTotal": 586.76,
      "orderViewCode": "YGXrGbZWlr29tIsGnYgR5o_8OxBMXWigevx1WD0X1Hc",
      "paymentInstruments": [
        {
          "amount": 20,
          "paymentInstrumentId": "ca47e0da3d49b067b630db624a",
          "paymentMethodId": "BML"
        },
        {
          "amount": 566.76,
          "paymentCard": {
            "cardType": "Visa",
            "creditCardExpired": false
          },
          "paymentInstrumentId": "6b970a04ca8a468a64b9936764",
          "paymentMethodId": "CREDIT_CARD"
        }
      ],
      "paymentStatus": "not_paid",
      "productItems": [
        {
          "adjustedTax": 30,
          "basePrice": 199.99,
          "bonusProductLineItem": false,
          "gift": false,
          "itemId": "d9516eecc64bd90b0022714d26",
          "itemText": "Green Umbrella - Sustained Edition",
          "optionItems": [
            {
              "adjustedTax": 0,
              "basePrice": 0,
              "bonusProductLineItem": false,
              "gift": false,
              "itemId": "8991e8d7adf0f46ffbc584e175",
              "itemText": "We will plant a tree for your order.",
              "optionId": "plantATree",
              "optionValueId": "000",
              "price": 0,
              "priceAfterItemDiscount": 0,
              "priceAfterOrderDiscount": 0,
              "productId": "000",
              "productName": "Plant a tree.",
              "quantity": 3,
              "shipmentId": "me",
              "tax": 0,
              "taxBasis": 0,
              "taxClassId": "standard",
              "taxRate": 0.05
            }
          ],
          "price": 599.99,
          "priceAfterItemDiscount": 599.99,
          "priceAfterOrderDiscount": 589.99,
          "productId": "green-umbrella",
          "productName": "Green Umbrella - Sustained Edition",
          "quantity": 3,
          "shipmentId": "me",
          "tax": 30,
          "taxBasis": 599.97,
          "taxClassId": "standard",
          "taxRate": 0.05
        }
      ],
      "productSubTotal": 599.97,
      "productTotal": 599.97,
      "shipments": [
        {
          "adjustedMerchandizeTotalTax": 37,
          "adjustedShippingTotalTax": 0.5,
          "deliveryWindow": {
            "startAt": "2026-05-04T14:00:00Z",
            "endAt": "2026-05-07T22:00:00Z"
          },
          "gift": false,
          "merchandizeTotalTax": 30,
          "orderCutoffAt": "2026-04-27T14:00:00Z",
          "productSubTotal": 599.97,
          "productTotal": 599.97,
          "shipmentId": "me",
          "shipmentTotal": 646.76,
          "shippingAddress": {
            "address1": "4162  Turkey Pen Road",
            "city": "New York",
            "countryCode": "US",
            "firstName": "Agustin",
            "fullName": "Agustin Estes",
            "id": "d5d95acf5381dc6e273b4336a7",
            "lastName": "Estes",
            "postalCode": "10016",
            "stateCode": "NY"
          },
          "shippingMethod": {
            "description": "Order received within 7-10 business days",
            "id": "001",
            "name": "Ground",
            "price": 15.99,
            "deliveryWindow": {
              "startAt": "2026-05-04T14:00:00Z",
              "endAt": "2026-05-07T22:00:00Z"
            },
            "orderCutoffAt": "2026-04-27T14:00:00Z"
          },
          "shippingStatus": "not_shipped",
          "shippingTotal": 15.99,
          "shippingTotalTax": 0.8,
          "taxTotal": 30.8
        }
      ],
      "shippingItems": [
        {
          "adjustedTax": 0.8,
          "basePrice": 15.99,
          "itemId": "768abee75aa8015239a9696c7e",
          "itemText": "Shipping",
          "price": 15.99,
          "priceAfterItemDiscount": 15.99,
          "shipmentId": "me",
          "tax": 0.8,
          "taxBasis": 15.99,
          "taxClassId": "standard",
          "taxRate": 0.05
        }
      ],
      "shippingStatus": "not_shipped",
      "shippingTotal": 15.99,
      "shippingTotalTax": 0.8,
      "status": "created",
      "taxation": "net",
      "taxTotal": 30.8
    }
    ```
    
*   **400**
    
    Possible reasons:
    
    *   a failure during the creation of a gift certificate for a gift certificate item.
    *   the basket ID in the request body is null or empty.
    *   an invalid product item.
    *   an option with the specified option ID is unknown.
    *   an option with the specified option value ID is unknown.
    *   a product item is not available.
    *   the customer assigned to the basket does not match the verified customer represented by the JWT token.
    *   the basket contains flashes (validation errors that prevent order placement).
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: BadRequest_
    
    ```
    {
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/bad-request",
      "title": "Bad Request",
      "detail": "Decoding of the property with path '$.failedExample.[1].intProperty' failed because the expected type is 'Integer|Decimal' but the actual type was 'String'."
    }
    ```
    
*   **404** The basket with the given basket ID is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: BasketNotFound_
    
    ```
    {
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/basket-not-found",
      "title": "Basket Not Found",
      "detail": "No basket with ID '123' could be found."
    }
    ```
    

### GET Retrieve Order Management (OMS) configuration data needed to render cancel and return experiences.

`GET /organizations/{organizationId}/orders/oms-meta-data`

Operation ID: `getOmsMetaData`. Security: ShopperToken (sfcc.shopper-baskets-orders, sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard); ShopperClientContextToken (sfcc.shopper-baskets-orders, sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard).

Retrieves configuration data from Order Management (OMS) required by the storefront to render cancel and return experiences. The response contains the reason codes configured in OMS for cancelling an order and for returning order items. Each reason code carries a `default` flag. When the caller omits a reason, the cancel and return endpoints (`cancelOmsOrder`, `returnOmsOrder`) apply the reason marked as `default` for that flow.

#### Parameters

*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `sfdc_usid` (header, string (uuid)) A unique shopper identifier (USID) for tracking client context. Used with endpoints secured with ShopperClientContextToken. This header is required for all endpoints secured with ShopperClientContextToken.  
    Example: `550e8400-e29b-41d4-a716-446655440000`.
*   `sfdc_dw_dnt` (header, string) Do Not Track header for privacy preferences. Used with endpoints secured with ShopperClientContextToken. If this header is not passed with endpoints secured with ShopperClientContextToken default value of 0 will be used.  
    Allowed values: `0`, `1`. Example: `1`.
*   `personalized` (query, string)
    
    Controls whether personalization is applied to the response. Set to `none` to opt out of personalized response handling so the response is safe to cache at the CDN layer.
    
    When set to `none`, the server skips applying personalization to the response.
    
    Setting `personalized=none` is necessary but not sufficient for CDN caching: a response is only cached when the endpoint is also cacheable in the [server-side web-tier cache](https://developer.salesforce.com/docs/commerce/commerce-api/guide/server-side-web-tier-caching.html), subject to its TTLs and invalidation. A call that is uncacheable in the web tier is not cached at the CDN either. See [CDN caching](https://developer.salesforce.com/docs/commerce/commerce-api/guide/cdn-caching.html).
    
      
    Allowed values: `none`. Example: `none`.
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Responses

*   **200** Success, the response body contains the OMS meta data.
    
    Media type: `application/json`. Schema: `OmsMetaData`.
    
    _Example: OmsMetaData_
    
    ```
    {
      "cancelReasonCodes": [
        {
          "reason": "Not specified",
          "default": true
        },
        {
          "reason": "Defect",
          "default": false
        },
        {
          "reason": "Wrong item",
          "default": false
        }
      ],
      "returnReasonCodes": [
        {
          "reason": "Not specified",
          "default": true
        },
        {
          "reason": "Defect",
          "default": false
        },
        {
          "reason": "Does not fit",
          "default": false
        }
      ]
    }
    ```
    
*   **409** Order Management (OMS) is not active for this site.
    
    Media type: `application/problem+json`. Schema: `OmsNotActiveErrorResponse`.
    
    _Example: OmsNotActiveErrorResponseExample_
    
    ```
    {
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/oms-not-active",
      "detail": "Order Management (OMS) is not active for this site.",
      "title": "Oms Not Active"
    }
    ```
    

#### Extension points

*   `sfcc.checkout.shopper-orders.v1.orders.oms-meta-data.modifyGETResponse` (modifyResponse) Called to modify the OMS meta data returned in the response.

### GET Retrieve order information.

`GET /organizations/{organizationId}/orders/{orderNo}`

Operation ID: `getOrder`. Security: ShopperToken (sfcc.shopper-baskets-orders, sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard); ShopperClientContextToken (sfcc.shopper-baskets-orders, sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard).

Gets information for an order.

#### Parameters

*   `orderNo` (path, OrderNo, required) The order number of the order to be modified.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `locale` (query, LocaleCode) A descriptor for a geographical region by both a language and country code. By combining these two, regional differences in a language can be addressed, such as with the request header parameter `Accept-Language` following [RFC 2616](https://tools.ietf.org/html/rfc2616) & [RFC 1766](https://tools.ietf.org/html/rfc1766). This can also just refer to a language code, also RFC 2616/1766 compliant, as a default if there is no specific match for a country. Finally, can also be used to define default behavior if there is no locale specified.
    
    _Example: LanguageCountry_
    
    ```
    en-US
    ```
    
    _Example: CountryCode_
    
    ```
    US
    ```
    
*   `expand` (query, array of string, style: form, explode: false) When you select 'oms' expand, data is loaded from Order Management (OMS), if available. When OMS data is available, the expand parameter has the following behavior: "expand=oms": order and related order entities (product & shipping items, delivery groups and price adjustments) are returned. "expand=oms\_shipments": order and fulfillment (shipment) data is returned. "expand=oms,oms\_shipments": order, related order entities and fulfillment (shipment) data are returned. If your instance is not integrated with OMS or the order data is not available, the `expand=oms` command is disregarded.  
    Items: Allowed values: `oms`, `oms_shipments`. Example: `oms`.
    
    _Example_
    
    ```
    oms,oms_shipments
    ```
    
*   `sfdc_usid` (header, string (uuid)) A unique shopper identifier (USID) for tracking client context. Used with endpoints secured with ShopperClientContextToken. This header is required for all endpoints secured with ShopperClientContextToken.  
    Example: `550e8400-e29b-41d4-a716-446655440000`.
*   `sfdc_dw_dnt` (header, string) Do Not Track header for privacy preferences. Used with endpoints secured with ShopperClientContextToken. If this header is not passed with endpoints secured with ShopperClientContextToken default value of 0 will be used.  
    Allowed values: `0`, `1`. Example: `1`.
*   `personalized` (query, string)
    
    Controls whether personalization is applied to the response. Set to `none` to opt out of personalized response handling so the response is safe to cache at the CDN layer.
    
    When set to `none`, the server skips applying personalization to the response.
    
    Setting `personalized=none` is necessary but not sufficient for CDN caching: a response is only cached when the endpoint is also cacheable in the [server-side web-tier cache](https://developer.salesforce.com/docs/commerce/commerce-api/guide/server-side-web-tier-caching.html), subject to its TTLs and invalidation. A call that is uncacheable in the web tier is not cached at the CDN either. See [CDN caching](https://developer.salesforce.com/docs/commerce/commerce-api/guide/cdn-caching.html).
    
      
    Allowed values: `none`. Example: `none`.
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Responses

*   **200** Success, the response body contains the order.
    
    Media type: `application/json`. Schema: `Order`.
    
    _Example Order: same as POST /organizations/{organizationId}/orders 200 response._
    
*   **404** The order with the given order number is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: BasketNotFound_
    
    ```
    {
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/basket-not-found",
      "title": "Basket Not Found",
      "detail": "No basket with ID '123' could be found."
    }
    ```
    

### POST Retrieve order information using a combination of non-token identifying factors.

`POST /organizations/{organizationId}/orders/{orderNo}/lookup`

Operation ID: `guestOrderLookup`. Security: ShopperToken (sfcc.shopper-baskets-orders, sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard); ShopperClientContextToken (sfcc.shopper-baskets-orders, sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard).

Retrieve order details using non-token identifiers or an authenticated shopper session.

The endpoint distinguishes between two levels of access: - Full access: Granted using shopper authentication, an OrderViewCode, or a time-limited access code. The OrderViewCode and access code are both passed in the `orderViewCode` request-body field; the server distinguishes them by format. Returns the complete order graph. - Partial access: Granted using a billing PostalCode paired with email or phone information. Filters sensitive data and Personally Identifiable Information (PII).

#### Parameters

*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `orderNo` (path, OrderNo, required) The order number of the order to be modified.
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `locale` (query, LocaleCode) A descriptor for a geographical region by both a language and country code. By combining these two, regional differences in a language can be addressed, such as with the request header parameter `Accept-Language` following [RFC 2616](https://tools.ietf.org/html/rfc2616) & [RFC 1766](https://tools.ietf.org/html/rfc1766). This can also just refer to a language code, also RFC 2616/1766 compliant, as a default if there is no specific match for a country. Finally, can also be used to define default behavior if there is no locale specified.
    
    _Example: LanguageCountry_
    
    ```
    en-US
    ```
    
    _Example: CountryCode_
    
    ```
    US
    ```
    
*   `expand` (query, array of string, style: form, explode: false) When you select 'oms' expand, data is loaded from Order Management (OMS), if available. When OMS data is available, the expand parameter has the following behavior: "expand=oms": order and related order entities (product & shipping items, delivery groups and price adjustments) are returned. "expand=oms\_shipments": order and fulfillment (shipment) data is returned. "expand=oms,oms\_shipments": order, related order entities and fulfillment (shipment) data are returned. If your instance is not integrated with OMS or the order data is not available, the `expand=oms` command is disregarded.  
    Items: Allowed values: `oms`, `oms_shipments`. Example: `oms`.
    
    _Example_
    
    ```
    oms,oms_shipments
    ```
    
*   `sfdc_usid` (header, string (uuid)) A unique shopper identifier (USID) for tracking client context. Used with endpoints secured with ShopperClientContextToken. This header is required for all endpoints secured with ShopperClientContextToken.  
    Example: `550e8400-e29b-41d4-a716-446655440000`.
*   `sfdc_dw_dnt` (header, string) Do Not Track header for privacy preferences. Used with endpoints secured with ShopperClientContextToken. If this header is not passed with endpoints secured with ShopperClientContextToken default value of 0 will be used.  
    Allowed values: `0`, `1`. Example: `1`.
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Request body

Media type: `application/json`. Schema: `OrderLookupRequest`.

_Example: OrderLookUp_

```
{
  "email": "no-reply@salesforce.com",
  "orderViewCode": "YGXrGbZWlr29tIsGnYgR5o_8OxBMXWigevx1WD0X1Hc"
}
```

_Example: OrderLookUpWithAccessCode_

```
{
  "orderViewCode": "847291"
}
```

#### Responses

*   **200** Success, the response returns the order, though sensitive details may be filtered based on access level.
    
    Media type: `application/json`. Schema: `Order`.
    
    _Example Order: same as POST /organizations/{organizationId}/orders 200 response._
    
    _Example: OrderPartialAccess_
    
    ```
    {
      "adjustedMerchandizeTotalTax": 30,
      "adjustedShippingTotalTax": 0.8,
      "billingAddress": {
        "postalCode": "01801"
      },
      "channelType": "storefront",
      "currency": "USD",
      "groupedTaxItems": [
        {
          "taxRate": 0.05,
          "taxValue": 30.8
        }
      ],
      "guest": true,
      "lastModified": "2019-10-22T12:17:28.376Z",
      "merchandizeTotalTax": 30,
      "orderNo": "00000410",
      "orderPriceAdjustments": [
        {
          "appliedDiscount": {
            "amount": 10,
            "type": "amount"
          },
          "reasonCode": "customer service",
          "creationDate": "2019-10-22T12:17:28.347Z",
          "custom": true,
          "lastModified": "2019-10-22T12:17:28.349Z",
          "manual": true,
          "price": -10,
          "priceAdjustmentId": "63b9eb9b4a92bd3e5c6ee804c2",
          "promotionId": "5ties"
        }
      ],
      "orderTotal": 586.76,
      "productItems": [
        {
          "adjustedTax": 30,
          "basePrice": 199.99,
          "bonusProductLineItem": false,
          "gift": false,
          "itemId": "d9516eecc64bd90b0022714d26",
          "itemText": "Green Umbrella - Sustained Edition",
          "optionItems": [
            {
              "adjustedTax": 0,
              "basePrice": 0,
              "bonusProductLineItem": false,
              "gift": false,
              "itemId": "8991e8d7adf0f46ffbc584e175",
              "itemText": "We will plant a tree for your order.",
              "optionId": "plantATree",
              "optionValueId": "000",
              "price": 0,
              "priceAfterItemDiscount": 0,
              "priceAfterOrderDiscount": 0,
              "productId": "000",
              "productName": "Plant a tree.",
              "quantity": 3,
              "shipmentId": "me",
              "tax": 0,
              "taxBasis": 0,
              "taxClassId": "standard",
              "taxRate": 0.05
            }
          ],
          "price": 599.99,
          "priceAfterItemDiscount": 599.99,
          "priceAfterOrderDiscount": 589.99,
          "productId": "green-umbrella",
          "productName": "Green Umbrella - Sustained Edition",
          "quantity": 3,
          "shipmentId": "me",
          "tax": 30,
          "taxBasis": 599.97,
          "taxClassId": "standard",
          "taxRate": 0.05
        }
      ],
      "productSubTotal": 599.97,
      "productTotal": 599.97,
      "shipments": [
        {
          "adjustedMerchandizeTotalTax": 37,
          "adjustedShippingTotalTax": 0.5,
          "gift": false,
          "merchandizeTotalTax": 30,
          "productSubTotal": 599.97,
          "productTotal": 599.97,
          "shipmentId": "me",
          "shipmentTotal": 646.76,
          "shippingMethod": {
            "description": "Order received within 7-10 business days.",
            "id": "001",
            "name": "Ground",
            "price": 15.99
          },
          "shippingTotal": 15.99,
          "shippingTotalTax": 0.8,
          "taxTotal": 30.8
        }
      ],
      "shippingItems": [
        {
          "adjustedTax": 0.8,
          "basePrice": 15.99,
          "itemId": "768abee75aa8015239a9696c7e",
          "itemText": "Shipping",
          "price": 15.99,
          "priceAfterItemDiscount": 15.99,
          "shipmentId": "me",
          "tax": 0.8,
          "taxBasis": 15.99,
          "taxClassId": "standard",
          "taxRate": 0.05
        }
      ],
      "shippingTotal": 15.99,
      "shippingTotalTax": 0.8,
      "status": "created",
      "taxation": "net",
      "taxTotal": 30.8
    }
    ```
    
*   **400**
    
    Possible reasons:
    
    *   The combination of identifying information is not sufficient for any access level.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: InsufficientIdentifyingInformation_
    
    ```
    {
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/insufficient-identifying-information",
      "title": "Insufficient Identifying Information",
      "detail": "Insufficient identifying information provided to retrieve the order."
    }
    ```
    
*   **404**
    
    Order was not found. Possible reasons:
    
    *   the order with the given order number is unknown.
    *   the combination of identifying information you provided, such as email or postal code, does not match the order record.
    *   the provided access code is invalid or has expired.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: OrderNotFound_
    
    ```
    {
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/order-not-found",
      "title": "Order Not Found",
      "detail": "No order with number '123' was found."
    }
    ```
    

### POST Fail an Order.

`POST /organizations/{organizationId}/orders/{orderNo}/actions/fail`

Operation ID: `failOrder`. Security: ShopperToken (sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard); ShopperClientContextToken (sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard).

Fails an unplaced order and optionally reopens the basket when indicated. Creates a HistoryEntry in the failed Order with provided reasonCode.

See also: Find more info on fail order behavior here: `https://salesforcecommercecloud.github.io/b2c-dev-doc/docs/current/scriptapi/html/index.html?target=class_dw_order_OrderMgr.html#dw_order_OrderMgr_failOrder_Order_Boolean_DetailAnchor`

#### Parameters

*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `orderNo` (path, OrderNo, required) The order number of the order to be modified.
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `locale` (query, LocaleCode) A descriptor for a geographical region by both a language and country code. By combining these two, regional differences in a language can be addressed, such as with the request header parameter `Accept-Language` following [RFC 2616](https://tools.ietf.org/html/rfc2616) & [RFC 1766](https://tools.ietf.org/html/rfc1766). This can also just refer to a language code, also RFC 2616/1766 compliant, as a default if there is no specific match for a country. Finally, can also be used to define default behavior if there is no locale specified.
    
    _Example: LanguageCountry_
    
    ```
    en-US
    ```
    
    _Example: CountryCode_
    
    ```
    US
    ```
    
*   `reopenBasket` (query, boolean) Set to true to reopen basket from the order. A basket can only be reopened if no other basket for the customer exists at the moment of the call to fail Order, since a customer is limited to 1 storefront basket at a time.  
    Default: `false`. Example: `false`.
*   `sfdc_usid` (header, string (uuid)) A unique shopper identifier (USID) for tracking client context. Used with endpoints secured with ShopperClientContextToken. This header is required for all endpoints secured with ShopperClientContextToken.  
    Example: `550e8400-e29b-41d4-a716-446655440000`.
*   `sfdc_dw_dnt` (header, string) Do Not Track header for privacy preferences. Used with endpoints secured with ShopperClientContextToken. If this header is not passed with endpoints secured with ShopperClientContextToken default value of 0 will be used.  
    Allowed values: `0`, `1`. Example: `1`.
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Request body

Media type: `application/json`. Schema: `FailOrderRequest`.

_Example: FailOrder_

```
{
  "reasonCode": "payment_confirm_failure"
}
```

#### Responses

*   **201** Order failed successfully. No content returned.
    
    Headers:
    
    *   `Location` (string) The location for accessing the reopened basket if one exists.
*   **204** Order failed successfully. No content returned.
*   **400**
    
    Possible reasons:
    
    *   Invalid request parameters.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example BadRequest: same as POST /organizations/{organizationId}/orders 400 response._
    
*   **404** The order with the given order number is unknown for the shopper.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: OrderNotFound_
    
    ```
    {
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/order-not-found",
      "title": "Order Not Found",
      "detail": "No order with number '123' was found."
    }
    ```
    
*   **409** The order is in invalid status.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: InvalidStateTransition_
    
    ```
    {
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/order-status-transition",
      "title": "Order Status Transition",
      "detail": "The order status change from 'Completed' to 'Failed' for order with number '00000335' isn't supported."
    }
    ```
    

### POST Cancel an order that is integrated with Order Management (OMS).

`POST /organizations/{organizationId}/orders/{orderNo}/actions/oms-cancel-order`

Operation ID: `cancelOmsOrder`. Security: ShopperToken (sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard); ShopperClientContextToken (sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard).

Cancels an order that is integrated with Order Management (OMS). The cancellation always applies to the entire order; partial cancellations are not supported.

#### Parameters

*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `orderNo` (path, OrderNo, required) The order number of the order to be modified.
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `locale` (query, LocaleCode) A descriptor for a geographical region by both a language and country code. By combining these two, regional differences in a language can be addressed, such as with the request header parameter `Accept-Language` following [RFC 2616](https://tools.ietf.org/html/rfc2616) & [RFC 1766](https://tools.ietf.org/html/rfc1766). This can also just refer to a language code, also RFC 2616/1766 compliant, as a default if there is no specific match for a country. Finally, can also be used to define default behavior if there is no locale specified.
    
    _Example: LanguageCountry_
    
    ```
    en-US
    ```
    
    _Example: CountryCode_
    
    ```
    US
    ```
    
*   `sfdc_usid` (header, string (uuid)) A unique shopper identifier (USID) for tracking client context. Used with endpoints secured with ShopperClientContextToken. This header is required for all endpoints secured with ShopperClientContextToken.  
    Example: `550e8400-e29b-41d4-a716-446655440000`.
*   `sfdc_dw_dnt` (header, string) Do Not Track header for privacy preferences. Used with endpoints secured with ShopperClientContextToken. If this header is not passed with endpoints secured with ShopperClientContextToken default value of 0 will be used.  
    Allowed values: `0`, `1`. Example: `1`.
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Request body (required)

Media type: `application/json`. Schema: `OmsCancelOrderRequest`.

_Example: OmsCancelOrder_

```
{
  "reason": "Wrong item"
}
```

_Example: OmsCancelOrderWithAccessCode_

```
{
  "reason": "Wrong item",
  "orderAccessCode": "847291"
}
```

#### Responses

*   **200** Success, the response body contains the updated order retrieved from Order Management (OMS).
    
    Media type: `application/json`. Schema: `Order`.
    
    _Example Order: same as POST /organizations/{organizationId}/orders 200 response._
    
*   **400**
    
    The cancel request is invalid. Possible reasons:
    
    *   The supplied reason code is not configured in Order Management (OMS).
    
    Media type: `application/problem+json`. Schema: `InvalidReasonCodeErrorResponse`.
    
    _Example: InvalidReasonCodeErrorResponseExample_
    
    ```
    {
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/invalid-reason-code",
      "detail": "The reason 'Damaged in transit' is not configured in Order Management (OMS).",
      "title": "Invalid Reason Code"
    }
    ```
    
*   **404**
    
    Order was not found. Possible reasons:
    
    *   the order with the given order number is unknown.
    *   the provided access code is invalid or has expired.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: OrderNotFound_
    
    ```
    {
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/order-not-found",
      "title": "Order Not Found",
      "detail": "No order with number '123' was found."
    }
    ```
    
*   **409**
    
    The order cannot be cancelled. Possible reasons:
    
    *   The order is no longer in a state that permits cancellation.
    *   Order Management (OMS) rejected the cancel request after ECOM accepted the input.
    *   Order Management (OMS) is not active for this site.
    
    Media type: `application/problem+json`. Schema: `OrderCancelFailedErrorResponse | OmsNotActiveErrorResponse`.
    
    One of: `OrderCancelFailedErrorResponse`, `OmsNotActiveErrorResponse`.
    
    _Example: OrderCancelFailedErrorResponseExample_
    
    ```
    {
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/order-cancel-failed",
      "detail": "Order '00000335' cannot be cancelled.",
      "title": "Order Cancel Failed"
    }
    ```
    
    _Example: OmsNotActiveErrorResponseExample_
    
    ```
    {
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/oms-not-active",
      "detail": "Order Management (OMS) is not active for this site.",
      "title": "Oms Not Active"
    }
    ```
    

#### Extension points

*   `sfcc.checkout.shopper-orders.v1.orders.orderNo.actions.oms-cancel-order.modifyPOSTResponse` (modifyResponse) Called to modify the order returned in the response after cancellation.

### POST Initiate the return of one or more items of an order that is integrated with Order Management (OMS).

`POST /organizations/{organizationId}/orders/{orderNo}/actions/oms-return-order`

Operation ID: `returnOmsOrder`. Security: ShopperToken (sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard); ShopperClientContextToken (sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard).

Initiates the return of one or more items of an order that is integrated with Order Management (OMS).

#### Parameters

*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `orderNo` (path, OrderNo, required) The order number of the order to be modified.
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `locale` (query, LocaleCode) A descriptor for a geographical region by both a language and country code. By combining these two, regional differences in a language can be addressed, such as with the request header parameter `Accept-Language` following [RFC 2616](https://tools.ietf.org/html/rfc2616) & [RFC 1766](https://tools.ietf.org/html/rfc1766). This can also just refer to a language code, also RFC 2616/1766 compliant, as a default if there is no specific match for a country. Finally, can also be used to define default behavior if there is no locale specified.
    
    _Example: LanguageCountry_
    
    ```
    en-US
    ```
    
    _Example: CountryCode_
    
    ```
    US
    ```
    
*   `sfdc_usid` (header, string (uuid)) A unique shopper identifier (USID) for tracking client context. Used with endpoints secured with ShopperClientContextToken. This header is required for all endpoints secured with ShopperClientContextToken.  
    Example: `550e8400-e29b-41d4-a716-446655440000`.
*   `sfdc_dw_dnt` (header, string) Do Not Track header for privacy preferences. Used with endpoints secured with ShopperClientContextToken. If this header is not passed with endpoints secured with ShopperClientContextToken default value of 0 will be used.  
    Allowed values: `0`, `1`. Example: `1`.
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Request body (required)

Media type: `application/json`. Schema: `OmsReturnOrderRequest`.

_Example: OmsReturnOrder_

```
{
  "productItems": [
    {
      "itemId": "10uVF0000003W0BYAU",
      "quantity": 1,
      "reason": "Does not fit"
    },
    {
      "itemId": "11uVF0000045W0BYAU",
      "quantity": 1,
      "reason": "Defect"
    }
  ]
}
```

_Example: OmsReturnOrderWithAccessCode_

```
{
  "productItems": [
    {
      "itemId": "10uVF0000003W0BYAU",
      "quantity": 1,
      "reason": "Does not fit"
    }
  ],
  "orderAccessCode": "847291"
}
```

#### Responses

*   **200** Success, the response body contains the updated order retrieved from Order Management (OMS).
    
    Media type: `application/json`. Schema: `Order`.
    
    _Example Order: same as POST /organizations/{organizationId}/orders 200 response._
    
*   **400**
    
    The return request is invalid. Possible reasons:
    
    *   The supplied reason code is not configured in Order Management (OMS).
    *   One or more of the supplied `productItems[].itemId` values do not match any product item of the order.
    *   The requested return quantity exceeds the quantity available to return for one or more items.
    
    Media type: `application/problem+json`. Schema: `InvalidReasonCodeErrorResponse | UnknownProductItemIdsErrorResponse | ReturnQuantityExceededErrorResponse`.
    
    One of: `InvalidReasonCodeErrorResponse`, `UnknownProductItemIdsErrorResponse`, `ReturnQuantityExceededErrorResponse`.
    
    _Example InvalidReasonCodeErrorResponseExample: same as POST /organizations/{organizationId}/orders/{orderNo}/actions/oms-cancel-order 400 response._
    
    _Example: UnknownProductItemIdsErrorResponseExample_
    
    ```
    {
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/unknown-product-item-ids",
      "detail": "One or more product item IDs in the request are not part of order '00000335'.",
      "title": "Unknown Product Item Ids"
    }
    ```
    
    _Example: ReturnQuantityExceededErrorResponseExample_
    
    ```
    {
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/return-quantity-exceeded",
      "detail": "The return request for order '00000335' exceeds the quantity available to return on one or more items.",
      "title": "Return Quantity Exceeded"
    }
    ```
    
*   **404**
    
    Order was not found. Possible reasons:
    
    *   the order with the given order number is unknown.
    *   the provided access code is invalid or has expired.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: OrderNotFound_
    
    ```
    {
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/order-not-found",
      "title": "Order Not Found",
      "detail": "No order with number '123' was found."
    }
    ```
    
*   **409**
    
    The order cannot be returned. Possible reasons:
    
    *   The order is no longer in a state that permits return of the requested items.
    *   Order Management (OMS) rejected the return after ECOM accepted the input.
    *   Order Management (OMS) is not active for this site.
    
    Media type: `application/problem+json`. Schema: `OrderReturnFailedErrorResponse | OmsNotActiveErrorResponse`.
    
    One of: `OrderReturnFailedErrorResponse`, `OmsNotActiveErrorResponse`.
    
    _Example: OrderReturnFailedErrorResponseExample_
    
    ```
    {
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/order-return-failed",
      "detail": "Order '00000335' cannot be returned.",
      "title": "Order Return Failed"
    }
    ```
    
    _Example: OmsNotActiveErrorResponseExample_
    
    ```
    {
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/oms-not-active",
      "detail": "Order Management (OMS) is not active for this site.",
      "title": "Oms Not Active"
    }
    ```
    

#### Extension points

*   `sfcc.checkout.shopper-orders.v1.orders.orderNo.actions.oms-return-order.modifyPOSTResponse` (modifyResponse) Called to modify the order returned in the response after the return was initiated.

### POST Request a time-limited access code for a guest order.

`POST /organizations/{organizationId}/orders/{orderNo}/actions/request-access-code`

Operation ID: `requestOrderAccessCode`. Security: ShopperToken (sfcc.shopper-baskets-orders, sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard); ShopperClientContextToken (sfcc.shopper-baskets-orders, sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard).

Generates a time-limited access code and delivers it via email to the address associated with the order. The shopper can then use this code with the lookup, cancel, and return endpoints to access the order without the original session.

The generated code is valid for 15 minutes. Too many incorrect access attempts invalidate the code early, but the 15-minute cooldown remains — a new code cannot be generated until the original validity period has elapsed, even if the code was invalidated early.

The endpoint always returns 202 — whether the order and email combination is valid, and whether a new code was generated. This uniform response prevents enumeration of valid orders and avoids revealing cooldown state to callers.

#### Parameters

*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `orderNo` (path, OrderNo, required) The order number of the order to be modified.
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `locale` (query, LocaleCode) A descriptor for a geographical region by both a language and country code. By combining these two, regional differences in a language can be addressed, such as with the request header parameter `Accept-Language` following [RFC 2616](https://tools.ietf.org/html/rfc2616) & [RFC 1766](https://tools.ietf.org/html/rfc1766). This can also just refer to a language code, also RFC 2616/1766 compliant, as a default if there is no specific match for a country. Finally, can also be used to define default behavior if there is no locale specified.
    
    _Example: LanguageCountry_
    
    ```
    en-US
    ```
    
    _Example: CountryCode_
    
    ```
    US
    ```
    
*   `expand` (query, array of string, style: form, explode: false) When you specify `expand=oms`, the integrated Order Management System (OMS) is included during the email validation. If your instance isn't integrated with OMS or the order data isn't available, B2C Commerce ignores the `expand=oms` parameter.  
    Items: Allowed values: `oms`. Example: `oms`.
    
    _Example_
    
    ```
    oms
    ```
    
*   `sfdc_usid` (header, string (uuid)) A unique shopper identifier (USID) for tracking client context. Used with endpoints secured with ShopperClientContextToken. This header is required for all endpoints secured with ShopperClientContextToken.  
    Example: `550e8400-e29b-41d4-a716-446655440000`.
*   `sfdc_dw_dnt` (header, string) Do Not Track header for privacy preferences. Used with endpoints secured with ShopperClientContextToken. If this header is not passed with endpoints secured with ShopperClientContextToken default value of 0 will be used.  
    Allowed values: `0`, `1`. Example: `1`.
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Request body (required)

Media type: `application/json`. Schema: `RequestOrderAccessCodeRequest`.

_Example: RequestOrderAccessCode_

```
{
  "email": "shopper@example.com"
}
```

#### Responses

*   **202** Accepted. Always returned, regardless of whether the order and email combination is valid, to prevent enumeration of valid orders. If the combination is valid, a new access code is generated and delivered via email.
*   **400**
    
    The access code request is invalid. Possible reasons:
    
    *   The email field is missing or empty.
    
    Media type: `application/problem+json`. Schema: `InvalidAccessCodeRequestErrorResponse`.
    
    _Example: InvalidAccessCodeRequestErrorResponseExample_
    
    ```
    {
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/invalid-access-code-request",
      "detail": "The access code request is invalid.",
      "title": "Invalid Access Code Request"
    }
    ```
    

#### Extension points

*   `sfcc.app.order.sendOrderAccessCode` (service-logic) Invoked to send the access code via email when the order number and email combination is valid.

### POST Add a payment instrument to an order.

`POST /organizations/{organizationId}/orders/{orderNo}/payment-instruments`

Operation ID: `createPaymentInstrumentForOrder`. Security: ShopperToken (sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard); ShopperClientContextToken (sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard).

Adds a payment instrument to an order.

Details:

The payment instrument is added with the provided details. The payment method must be applicable for the order see GET /baskets/{basketId}/payment-methods, if the payment method is 'CREDIT\_CARD' a paymentCard must be specified in the request.

#### Parameters

*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `orderNo` (path, OrderNo, required) The order number of the order to be modified.
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `locale` (query, LocaleCode) A descriptor for a geographical region by both a language and country code. By combining these two, regional differences in a language can be addressed, such as with the request header parameter `Accept-Language` following [RFC 2616](https://tools.ietf.org/html/rfc2616) & [RFC 1766](https://tools.ietf.org/html/rfc1766). This can also just refer to a language code, also RFC 2616/1766 compliant, as a default if there is no specific match for a country. Finally, can also be used to define default behavior if there is no locale specified.
    
    _Example: LanguageCountry_
    
    ```
    en-US
    ```
    
    _Example: CountryCode_
    
    ```
    US
    ```
    
*   `sfdc_usid` (header, string (uuid)) A unique shopper identifier (USID) for tracking client context. Used with endpoints secured with ShopperClientContextToken. This header is required for all endpoints secured with ShopperClientContextToken.  
    Example: `550e8400-e29b-41d4-a716-446655440000`.
*   `sfdc_dw_dnt` (header, string) Do Not Track header for privacy preferences. Used with endpoints secured with ShopperClientContextToken. If this header is not passed with endpoints secured with ShopperClientContextToken default value of 0 will be used.  
    Allowed values: `0`, `1`. Example: `1`.
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Request body

Media type: `application/json`. Schema: `OrderPaymentInstrumentRequest`.

_Example: PaymentInstrumentPost_

```
{
  "amount": 700,
  "paymentCard": {
    "expirationYear": 1990,
    "expirationMonth": 7,
    "validFromMonth": 8,
    "validFromYear": 2007,
    "issueNumber": "i117",
    "maskedNumber": "************4567",
    "holder": "Miller",
    "cardType": "Visa"
  },
  "paymentMethodId": "CREDIT_CARD"
}
```

#### Responses

*   **200** Success, the response body contains the order with the added payment instrument.
    
    Media type: `application/json`. Schema: `Order`.
    
    _Example: Order_
    
    ```
    {
      "adjustedMerchandizeTotalTax": 30,
      "adjustedShippingTotalTax": 0.8,
      "billingAddress": {
        "address1": "104 Presidential Way",
        "city": "Woburn",
        "countryCode": "US",
        "firstName": "Stephanie",
        "fullName": "Stephanie Miller",
        "id": "5f695b6f4bb63cb686483d65a0",
        "lastName": "Miller",
        "postalCode": "01801",
        "stateCode": "MA"
      },
      "channelType": "storefront",
      "confirmationStatus": "not_confirmed",
      "couponItems": [
        {
          "code": "5ties",
          "couponItemId": "d3f7ae47e5897a6b5d2fd541f0",
          "statusCode": "applied",
          "valid": true
        }
      ],
      "createdBy": "Customer",
      "creationDate": "2019-10-22T12:17:28.341Z",
      "currency": "USD",
      "customerInfo": {
        "customerId": "beQeANXJNsd0xcINsB6cSrobQa",
        "customerName": "Stephanie Miller",
        "email": "shopper@salesforce-test.com"
      },
      "customerName": "Stephanie Miller",
      "exportStatus": "not_exported",
      "groupedTaxItems": [
        {
          "taxRate": 0.05,
          "taxValue": 30.8
        }
      ],
      "guest": true,
      "giftCertificateItems": [
        {
          "amount": 1,
          "giftCertificateItemId": "540db3ffe58bfb04ab673757d7",
          "recipientEmail": "miller@salesforce-test.com",
          "shipmentId": "me"
        }
      ],
      "lastModified": "2019-10-22T12:17:28.376Z",
      "merchandizeTotalTax": 30,
      "orderNo": "00000410",
      "orderPriceAdjustments": [
        {
          "appliedDiscount": {
            "amount": 10,
            "type": "amount"
          },
          "reasonCode": "customer service",
          "createdBy": "support",
          "creationDate": "2019-10-22T12:17:28.347Z",
          "custom": true,
          "lastModified": "2019-10-22T12:17:28.349Z",
          "manual": true,
          "price": -10,
          "priceAdjustmentId": "63b9eb9b4a92bd3e5c6ee804c2",
          "promotionId": "5ties"
        }
      ],
      "orderToken": "7gJDIFlnho_mXrxfxVB9Neic3J7szzR9glvgU5Ath-I",
      "orderTotal": 586.76,
      "orderViewCode": "YGXrGbZWlr29tIsGnYgR5o_8OxBMXWigevx1WD0X1Hc",
      "paymentInstruments": [
        {
          "amount": 20,
          "paymentInstrumentId": "ca47e0da3d49b067b630db624a",
          "paymentMethodId": "BML"
        },
        {
          "amount": 566.76,
          "paymentCard": {
            "cardType": "Visa",
            "creditCardExpired": false
          },
          "paymentInstrumentId": "6b970a04ca8a468a64b9936764",
          "paymentMethodId": "CREDIT_CARD"
        },
        {
          "amount": 700,
          "paymentCard": {
            "expirationYear": 1990,
            "expirationMonth": 7,
            "validFromMonth": 8,
            "validFromYear": 2007,
            "issueNumber": "i117",
            "maskedNumber": "************4567",
            "holder": "Miller",
            "cardType": "Visa"
          },
          "paymentInstrumentId": "9f21f0b51f206fbde2ff5789e5",
          "paymentMethodId": "CREDIT_CARD"
        }
      ],
      "paymentStatus": "not_paid",
      "productItems": [
        {
          "adjustedTax": 30,
          "basePrice": 199.99,
          "bonusProductLineItem": false,
          "gift": false,
          "itemId": "d9516eecc64bd90b0022714d26",
          "itemText": "Green Umbrella - Sustained Edition",
          "optionItems": [
            {
              "adjustedTax": 0,
              "basePrice": 0,
              "bonusProductLineItem": false,
              "gift": false,
              "itemId": "8991e8d7adf0f46ffbc584e175",
              "itemText": "We will plant a tree for your order.",
              "optionId": "plantATree",
              "optionValueId": "000",
              "price": 0,
              "priceAfterItemDiscount": 0,
              "priceAfterOrderDiscount": 0,
              "productId": "000",
              "productName": "Plant a tree.",
              "quantity": 3,
              "shipmentId": "me",
              "tax": 0,
              "taxBasis": 0,
              "taxClassId": "standard",
              "taxRate": 0.05
            }
          ],
          "price": 599.99,
          "priceAfterItemDiscount": 599.99,
          "priceAfterOrderDiscount": 589.99,
          "productId": "green-umbrella",
          "productName": "Green Umbrella - Sustained Edition",
          "quantity": 3,
          "shipmentId": "me",
          "tax": 30,
          "taxBasis": 599.97,
          "taxClassId": "standard",
          "taxRate": 0.05
        }
      ],
      "productSubTotal": 599.97,
      "productTotal": 599.97,
      "shipments": [
        {
          "adjustedMerchandizeTotalTax": 37,
          "adjustedShippingTotalTax": 0.5,
          "deliveryWindow": {
            "startAt": "2026-05-04T14:00:00Z",
            "endAt": "2026-05-07T22:00:00Z"
          },
          "gift": false,
          "merchandizeTotalTax": 30,
          "orderCutoffAt": "2026-04-27T14:00:00Z",
          "productSubTotal": 599.97,
          "productTotal": 599.97,
          "shipmentId": "me",
          "shipmentTotal": 646.76,
          "shippingAddress": {
            "address1": "4162  Turkey Pen Road",
            "city": "New York",
            "countryCode": "US",
            "firstName": "Agustin",
            "fullName": "Agustin Estes",
            "id": "d5d95acf5381dc6e273b4336a7",
            "lastName": "Estes",
            "postalCode": "10016",
            "stateCode": "NY"
          },
          "shippingMethod": {
            "description": "Order received within 7-10 business days",
            "id": "001",
            "name": "Ground",
            "price": 15.99,
            "deliveryWindow": {
              "startAt": "2026-05-04T14:00:00Z",
              "endAt": "2026-05-07T22:00:00Z"
            },
            "orderCutoffAt": "2026-04-27T14:00:00Z"
          },
          "shippingStatus": "not_shipped",
          "shippingTotal": 15.99,
          "shippingTotalTax": 0.8,
          "taxTotal": 30.8
        }
      ],
      "shippingItems": [
        {
          "adjustedTax": 0.8,
          "basePrice": 15.99,
          "itemId": "768abee75aa8015239a9696c7e",
          "itemText": "Shipping",
          "price": 15.99,
          "priceAfterItemDiscount": 15.99,
          "shipmentId": "me",
          "tax": 0.8,
          "taxBasis": 15.99,
          "taxClassId": "standard",
          "taxRate": 0.05
        }
      ],
      "shippingStatus": "not_shipped",
      "shippingTotal": 15.99,
      "shippingTotalTax": 0.8,
      "status": "new",
      "taxation": "net",
      "taxTotal": 30.8
    }
    ```
    
*   **400**
    
    Possible reasons:
    
    *   the given order number is invalid.
    *   the provided payment method is invalid or not applicable.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example BadRequest: same as POST /organizations/{organizationId}/orders 400 response._
    
*   **404** The order with the given order number is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: OrderNotFound_
    
    ```
    {
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/order-not-found",
      "title": "Order Not Found",
      "detail": "No order with number '123' was found."
    }
    ```
    

### DELETE Remove a payment instrument from an order.

`DELETE /organizations/{organizationId}/orders/{orderNo}/payment-instruments/{paymentInstrumentId}`

Operation ID: `removePaymentInstrumentFromOrder`. Security: ShopperToken (sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard); ShopperClientContextToken (sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard).

Removes a payment instrument of an order.

#### Parameters

*   `paymentInstrumentId` (path, PaymentInstrumentId, required)
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `orderNo` (path, OrderNo, required) The order number of the order to be modified.
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `locale` (query, LocaleCode) A descriptor for a geographical region by both a language and country code. By combining these two, regional differences in a language can be addressed, such as with the request header parameter `Accept-Language` following [RFC 2616](https://tools.ietf.org/html/rfc2616) & [RFC 1766](https://tools.ietf.org/html/rfc1766). This can also just refer to a language code, also RFC 2616/1766 compliant, as a default if there is no specific match for a country. Finally, can also be used to define default behavior if there is no locale specified.
    
    _Example: LanguageCountry_
    
    ```
    en-US
    ```
    
    _Example: CountryCode_
    
    ```
    US
    ```
    
*   `sfdc_usid` (header, string (uuid)) A unique shopper identifier (USID) for tracking client context. Used with endpoints secured with ShopperClientContextToken. This header is required for all endpoints secured with ShopperClientContextToken.  
    Example: `550e8400-e29b-41d4-a716-446655440000`.
*   `sfdc_dw_dnt` (header, string) Do Not Track header for privacy preferences. Used with endpoints secured with ShopperClientContextToken. If this header is not passed with endpoints secured with ShopperClientContextToken default value of 0 will be used.  
    Allowed values: `0`, `1`. Example: `1`.
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Responses

*   **200** Success, the response body contains the order without the deleted payment instrument.
    
    Media type: `application/json`. Schema: `Order`.
    
*   **404**
    
    Possible reasons:
    
    *   The order with the given order number is unknown.
    *   The payment instrument with the given order payment instrument ID is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: OrderNotFound_
    
    ```
    {
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/order-not-found",
      "title": "Order Not Found",
      "detail": "No order with number '123' was found."
    }
    ```
    

### PATCH Update payment instrument details for an order.

`PATCH /organizations/{organizationId}/orders/{orderNo}/payment-instruments/{paymentInstrumentId}`

Operation ID: `updatePaymentInstrumentForOrder`. Security: ShopperToken (sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard); ShopperClientContextToken (sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard).

Updates a payment instrument of an order.

Details:

The payment instrument is updated with the provided details. The payment method must be applicable for the order see GET /baskets/{basketId}/payment-methods, if the payment method is 'CREDIT\_CARD' a paymentCard must be specified in the request.

#### Parameters

*   `paymentInstrumentId` (path, PaymentInstrumentId, required)
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `orderNo` (path, OrderNo, required) The order number of the order to be modified.
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `locale` (query, LocaleCode) A descriptor for a geographical region by both a language and country code. By combining these two, regional differences in a language can be addressed, such as with the request header parameter `Accept-Language` following [RFC 2616](https://tools.ietf.org/html/rfc2616) & [RFC 1766](https://tools.ietf.org/html/rfc1766). This can also just refer to a language code, also RFC 2616/1766 compliant, as a default if there is no specific match for a country. Finally, can also be used to define default behavior if there is no locale specified.
    
    _Example: LanguageCountry_
    
    ```
    en-US
    ```
    
    _Example: CountryCode_
    
    ```
    US
    ```
    
*   `sfdc_usid` (header, string (uuid)) A unique shopper identifier (USID) for tracking client context. Used with endpoints secured with ShopperClientContextToken. This header is required for all endpoints secured with ShopperClientContextToken.  
    Example: `550e8400-e29b-41d4-a716-446655440000`.
*   `sfdc_dw_dnt` (header, string) Do Not Track header for privacy preferences. Used with endpoints secured with ShopperClientContextToken. If this header is not passed with endpoints secured with ShopperClientContextToken default value of 0 will be used.  
    Allowed values: `0`, `1`. Example: `1`.
*   `sfdc_shopper_context` (header, string) Shopper context information (for example clientIP, sourceCode, and customQualifiers) passed in from a trusted backend application.

#### Request body

Media type: `application/json`. Schema: `OrderPaymentInstrumentRequest`.

_Example: PaymentInstrumentPatch_

```
{
  "amount": 2,
  "paymentMethodId": "CREDIT_CARD",
  "paymentCard": {
    "cardType": "Visa",
    "maskedNumber": "****-****-****-4567"
  }
}
```

_Example: PaymentInstrumentPatchWithSalesforcePayments_

```
{
  "amount": 700,
  "paymentMethodId": "Salesforce Payments",
  "paymentReferenceRequest": {
    "paymentMethodType": "card",
    "zoneId": "Amer-Zone",
    "gateway": "stripe",
    "gatewayProperties": {
      "stripe": {
        "setupFutureUsage": "on_session"
      }
    }
  }
}
```

#### Responses

*   **200** Success, the response body contains the order with the updated payment instrument. When Salesforce Payments is enabled, the paymentReference object will be included in the paymentInstruments.
    
    Media type: `application/json`. Schema: `Order`.
    
    _Example: Order_
    
    ```
    {
      "adjustedMerchandizeTotalTax": 30,
      "adjustedShippingTotalTax": 0.8,
      "billingAddress": {
        "address1": "104 Presidential Way",
        "city": "Woburn",
        "countryCode": "US",
        "firstName": "Stephanie",
        "fullName": "Stephanie Miller",
        "id": "5f695b6f4bb63cb686483d65a0",
        "lastName": "Miller",
        "postalCode": "01801",
        "stateCode": "MA"
      },
      "channelType": "storefront",
      "confirmationStatus": "not_confirmed",
      "couponItems": [
        {
          "code": "5ties",
          "couponItemId": "d3f7ae47e5897a6b5d2fd541f0",
          "statusCode": "applied",
          "valid": true
        }
      ],
      "createdBy": "Customer",
      "creationDate": "2019-10-22T12:17:28.341Z",
      "currency": "USD",
      "customerInfo": {
        "customerId": "beQeANXJNsd0xcINsB6cSrobQa",
        "customerName": "Stephanie Miller",
        "email": "shopper@salesforce-test.com"
      },
      "customerName": "Stephanie Miller",
      "exportStatus": "not_exported",
      "groupedTaxItems": [
        {
          "taxRate": 0.05,
          "taxValue": 30.8
        }
      ],
      "guest": true,
      "giftCertificateItems": [
        {
          "amount": 1,
          "giftCertificateItemId": "540db3ffe58bfb04ab673757d7",
          "recipientEmail": "miller@salesforce-test.com",
          "shipmentId": "me"
        }
      ],
      "lastModified": "2019-10-22T12:17:28.376Z",
      "merchandizeTotalTax": 30,
      "orderNo": "00000410",
      "orderPriceAdjustments": [
        {
          "appliedDiscount": {
            "amount": 10,
            "type": "amount"
          },
          "reasonCode": "customer service",
          "createdBy": "support",
          "creationDate": "2019-10-22T12:17:28.347Z",
          "custom": true,
          "lastModified": "2019-10-22T12:17:28.349Z",
          "manual": true,
          "price": -10,
          "priceAdjustmentId": "63b9eb9b4a92bd3e5c6ee804c2",
          "promotionId": "5ties"
        }
      ],
      "orderToken": "7gJDIFlnho_mXrxfxVB9Neic3J7szzR9glvgU5Ath-I",
      "orderTotal": 586.76,
      "orderViewCode": "YGXrGbZWlr29tIsGnYgR5o_8OxBMXWigevx1WD0X1Hc",
      "paymentInstruments": [
        {
          "amount": 20,
          "paymentInstrumentId": "ca47e0da3d49b067b630db624a",
          "paymentMethodId": "BML"
        },
        {
          "amount": 566.76,
          "paymentCard": {
            "cardType": "Visa",
            "creditCardExpired": false
          },
          "paymentInstrumentId": "6b970a04ca8a468a64b9936764",
          "paymentMethodId": "CREDIT_CARD"
        },
        {
          "amount": 2,
          "paymentCard": {
            "expirationYear": 1990,
            "expirationMonth": 7,
            "validFromMonth": 8,
            "validFromYear": 2007,
            "issueNumber": "i117",
            "maskedNumber": "******4567",
            "holder": "Miller",
            "cardType": "Visa"
          },
          "paymentInstrumentId": "9f21f0b51f206fbde2ff5789e5",
          "paymentMethodId": "CREDIT_CARD"
        }
      ],
      "paymentStatus": "not_paid",
      "productItems": [
        {
          "adjustedTax": 30,
          "basePrice": 199.99,
          "bonusProductLineItem": false,
          "gift": false,
          "itemId": "d9516eecc64bd90b0022714d26",
          "itemText": "Green Umbrella - Sustained Edition",
          "optionItems": [
            {
              "adjustedTax": 0,
              "basePrice": 0,
              "bonusProductLineItem": false,
              "gift": false,
              "itemId": "8991e8d7adf0f46ffbc584e175",
              "itemText": "We will plant a tree for your order.",
              "optionId": "plantATree",
              "optionValueId": "000",
              "price": 0,
              "priceAfterItemDiscount": 0,
              "priceAfterOrderDiscount": 0,
              "productId": "000",
              "productName": "Plant a tree.",
              "quantity": 3,
              "shipmentId": "me",
              "tax": 0,
              "taxBasis": 0,
              "taxClassId": "standard",
              "taxRate": 0.05
            }
          ],
          "price": 599.99,
          "priceAfterItemDiscount": 599.99,
          "priceAfterOrderDiscount": 589.99,
          "productId": "green-umbrella",
          "productName": "Green Umbrella - Sustained Edition",
          "quantity": 3,
          "shipmentId": "me",
          "tax": 30,
          "taxBasis": 599.97,
          "taxClassId": "standard",
          "taxRate": 0.05
        }
      ],
      "productSubTotal": 599.97,
      "productTotal": 599.97,
      "shipments": [
        {
          "adjustedMerchandizeTotalTax": 37,
          "adjustedShippingTotalTax": 0.5,
          "deliveryWindow": {
            "startAt": "2026-05-04T14:00:00Z",
            "endAt": "2026-05-07T22:00:00Z"
          },
          "gift": false,
          "merchandizeTotalTax": 30,
          "orderCutoffAt": "2026-04-27T14:00:00Z",
          "productSubTotal": 599.97,
          "productTotal": 599.97,
          "shipmentId": "me",
          "shipmentTotal": 646.76,
          "shippingAddress": {
            "address1": "4162  Turkey Pen Road",
            "city": "New York",
            "countryCode": "US",
            "firstName": "Agustin",
            "fullName": "Agustin Estes",
            "id": "d5d95acf5381dc6e273b4336a7",
            "lastName": "Estes",
            "postalCode": "10016",
            "stateCode": "NY"
          },
          "shippingMethod": {
            "description": "Order received within 7-10 business days",
            "id": "001",
            "name": "Ground",
            "price": 15.99,
            "deliveryWindow": {
              "startAt": "2026-05-04T14:00:00Z",
              "endAt": "2026-05-07T22:00:00Z"
            },
            "orderCutoffAt": "2026-04-27T14:00:00Z"
          },
          "shippingStatus": "not_shipped",
          "shippingTotal": 15.99,
          "shippingTotalTax": 0.8,
          "taxTotal": 30.8
        }
      ],
      "shippingItems": [
        {
          "adjustedTax": 0.8,
          "basePrice": 15.99,
          "itemId": "768abee75aa8015239a9696c7e",
          "itemText": "Shipping",
          "price": 15.99,
          "priceAfterItemDiscount": 15.99,
          "shipmentId": "me",
          "tax": 0.8,
          "taxBasis": 15.99,
          "taxClassId": "standard",
          "taxRate": 0.05
        }
      ],
      "shippingStatus": "not_shipped",
      "shippingTotal": 15.99,
      "shippingTotalTax": 0.8,
      "status": "new",
      "taxation": "net",
      "taxTotal": 30.8
    }
    ```
    
    _Example: OrderWhenSalesforcePaymentsEnabled_
    
    ```
    {
      "adjustedMerchandizeTotalTax": 30,
      "adjustedShippingTotalTax": 0.8,
      "billingAddress": {
        "address1": "104 Presidential Way",
        "city": "Woburn",
        "countryCode": "US",
        "firstName": "Stephanie",
        "fullName": "Stephanie Miller",
        "id": "5f695b6f4bb63cb686483d65a0",
        "lastName": "Miller",
        "postalCode": "01801",
        "stateCode": "MA"
      },
      "channelType": "storefront",
      "confirmationStatus": "not_confirmed",
      "couponItems": [
        {
          "code": "5ties",
          "couponItemId": "d3f7ae47e5897a6b5d2fd541f0",
          "statusCode": "applied",
          "valid": true
        }
      ],
      "createdBy": "Customer",
      "creationDate": "2019-10-22T12:17:28.341Z",
      "currency": "USD",
      "customerInfo": {
        "customerId": "beQeANXJNsd0xcINsB6cSrobQa",
        "customerName": "Stephanie Miller",
        "email": "shopper@salesforce-test.com"
      },
      "customerName": "Stephanie Miller",
      "exportStatus": "not_exported",
      "groupedTaxItems": [
        {
          "taxRate": 0.05,
          "taxValue": 30.8
        }
      ],
      "guest": true,
      "giftCertificateItems": [
        {
          "amount": 1,
          "giftCertificateItemId": "540db3ffe58bfb04ab673757d7",
          "recipientEmail": "miller@salesforce-test.com",
          "shipmentId": "me"
        }
      ],
      "lastModified": "2019-10-22T12:17:28.376Z",
      "merchandizeTotalTax": 30,
      "orderNo": "00000410",
      "orderPriceAdjustments": [
        {
          "appliedDiscount": {
            "amount": 10,
            "type": "amount"
          },
          "reasonCode": "customer service",
          "createdBy": "support",
          "creationDate": "2019-10-22T12:17:28.347Z",
          "custom": true,
          "lastModified": "2019-10-22T12:17:28.349Z",
          "manual": true,
          "price": -10,
          "priceAdjustmentId": "63b9eb9b4a92bd3e5c6ee804c2",
          "promotionId": "5ties"
        }
      ],
      "orderToken": "7gJDIFlnho_mXrxfxVB9Neic3J7szzR9glvgU5Ath-I",
      "orderTotal": 586.76,
      "orderViewCode": "YGXrGbZWlr29tIsGnYgR5o_8OxBMXWigevx1WD0X1Hc",
      "paymentInstruments": [
        {
          "amount": 20,
          "paymentInstrumentId": "ca47e0da3d49b067b630db624a",
          "paymentMethodId": "PAYPAL",
          "paymentReference": {
            "paymentReferenceId": "PAY-1AB23456CD789012EF34GHIJ"
          }
        },
        {
          "amount": 566.76,
          "paymentCard": {
            "cardType": "Visa",
            "creditCardExpired": false
          },
          "paymentInstrumentId": "6b970a04ca8a468a64b9936764",
          "paymentMethodId": "CREDIT_CARD",
          "paymentReference": {
            "paymentReferenceId": "8815749596351791C"
          }
        },
        {
          "amount": 2,
          "paymentCard": {
            "expirationYear": 1990,
            "expirationMonth": 7,
            "validFromMonth": 8,
            "validFromYear": 2007,
            "issueNumber": "i117",
            "maskedNumber": "******4567",
            "holder": "Miller",
            "cardType": "Visa"
          },
          "paymentInstrumentId": "9f21f0b51f206fbde2ff5789e5",
          "paymentMethodId": "CREDIT_CARD",
          "paymentReference": {
            "paymentReferenceId": "pi_1J4K5L2eZvKYlo2CyZ8K5L6M",
            "gateway": "stripe",
            "gatewayProperties": {
              "stripe": {
                "setupFutureUsage": "on_session",
                "clientSecret": "pi_1J4K5L2eZvKYlo2CyZ8K5L6M_secret_abcdef123456"
              }
            }
          }
        }
      ],
      "paymentStatus": "not_paid",
      "productItems": [
        {
          "adjustedTax": 30,
          "basePrice": 199.99,
          "bonusProductLineItem": false,
          "gift": false,
          "itemId": "d9516eecc64bd90b0022714d26",
          "itemText": "Green Umbrella - Sustained Edition",
          "optionItems": [
            {
              "adjustedTax": 0,
              "basePrice": 0,
              "bonusProductLineItem": false,
              "gift": false,
              "itemId": "8991e8d7adf0f46ffbc584e175",
              "itemText": "Monogramming: Letter \"A\"",
              "optionId": "textMonogramLetters",
              "optionValueId": "A",
              "price": 0,
              "priceAfterItemDiscount": 0,
              "priceAfterOrderDiscount": 0,
              "productId": "701643632930",
              "productName": "Flat Front Pant",
              "shipmentId": "me",
              "tax": 0,
              "taxBasis": 0,
              "taxRate": 0.05
            }
          ],
          "priceAfterItemDiscount": 199.99,
          "priceAfterOrderDiscount": 199.99,
          "productId": "701643632930",
          "productName": "Green Umbrella - Sustained Edition",
          "quantity": 1,
          "shipmentId": "me",
          "tax": 30,
          "taxBasis": 199.99,
          "taxRate": 0.05
        }
      ],
      "productSubTotal": 199.99,
      "productTotal": 199.99,
      "shipments": [
        {
          "adjustedMerchandizeTotalTax": 30,
          "adjustedShippingTotalTax": 0.8,
          "gift": false,
          "merchandizeTotalTax": 199.99,
          "productSubTotal": 199.99,
          "productTotal": 199.99,
          "shipmentId": "me",
          "shipmentNo": "00000001",
          "shipmentTotal": 386.75,
          "shippingAddress": {
            "address1": "104 Presidential Way",
            "city": "Woburn",
            "countryCode": "US",
            "firstName": "Stephanie",
            "fullName": "Stephanie Miller",
            "id": "5f695b6f4bb63cb686483d65a0",
            "lastName": "Miller",
            "postalCode": "01801",
            "stateCode": "MA"
          },
          "shippingMethod": {
            "description": "Order within the next 3 hours to get it tomorrow morning",
            "id": "EXPRESS",
            "name": "Express",
            "price": 15.99,
            "shippingPromotions": [
              {
                "calloutMsg": "Free shipping amount has been reduced!",
                "promotionId": "freeshipping_level1",
                "promotionName": "Free shipping Level 1"
              }
            ]
          },
          "shippingStatus": "not_shipped",
          "shippingTotal": 15.99,
          "shippingTotalTax": 0.8,
          "taxTotal": 30.8
        }
      ],
      "shippingItems": [
        {
          "adjustedTax": 0.8,
          "basePrice": 15.99,
          "itemId": "768abee75aa8015239a9696c7e",
          "itemText": "Shipping",
          "priceAfterItemDiscount": 15.99,
          "shipmentId": "me",
          "tax": 0.8,
          "taxBasis": 15.99,
          "taxRate": 0.05
        }
      ],
      "shippingStatus": "not_shipped",
      "shippingTotal": 15.99,
      "shippingTotalTax": 0.8,
      "status": "new",
      "taxation": "net",
      "taxTotal": 30.8
    }
    ```
    
*   **400**
    
    Possible reasons:
    
    *   the basket payment instrument with the given ID already is permanently masked.
    *   the provided payment method is invalid or not applicable.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example BadRequest: same as POST /organizations/{organizationId}/orders 400 response._
    
*   **404**
    
    Possible reasons:
    
    *   The order with the given order number is unknown.
    *   The payment instrument with the given payment instrument ID is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: OrderNotFound_
    
    ```
    {
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/order-not-found",
      "title": "Order Not Found",
      "detail": "No order with number '123' was found."
    }
    ```
    

### GET Retrieve payment instrument details for an order.

`GET /organizations/{organizationId}/orders/{orderNo}/payment-methods`

Operation ID: `getPaymentMethodsForOrder`. Security: ShopperToken (sfcc.shopper-baskets-orders, sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard); ShopperClientContextToken (sfcc.shopper-baskets-orders, sfcc.shopper-baskets-orders.rw, sfcc.shopper-standard).

Gets the applicable payment methods for an existing order considering the open payment amount only.

#### Parameters

*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `orderNo` (path, OrderNo, required) The order number of the order to be modified.
*   `siteId` (query, SiteId, required) The identifier of the site that a request is being made in the context of. Attributes might have site specific values, and some objects may only be assigned to specific sites.
    
    _Example: SiteId_
    
    ```
    RefArch
    ```
    
*   `locale` (query, LocaleCode) A descriptor for a geographical region by both a language and country code. By combining these two, regional differences in a language can be addressed, such as with the request header parameter `Accept-Language` following [RFC 2616](https://tools.ietf.org/html/rfc2616) & [RFC 1766](https://tools.ietf.org/html/rfc1766). This can also just refer to a language code, also RFC 2616/1766 compliant, as a default if there is no specific match for a country. Finally, can also be used to define default behavior if there is no locale specified.
    
    _Example: LanguageCountry_
    
    ```
    en-US
    ```
    
    _Example: CountryCode_
    
    ```
    US
    ```
    
*   `sfdc_usid` (header, string (uuid)) A unique shopper identifier (USID) for tracking client context. Used with endpoints secured with ShopperClientContextToken. This header is required for all endpoints secured with ShopperClientContextToken.  
    Example: `550e8400-e29b-41d4-a716-446655440000`.
*   `sfdc_dw_dnt` (header, string) Do Not Track header for privacy preferences. Used with endpoints secured with ShopperClientContextToken. If this header is not passed with endpoints secured with ShopperClientContextToken default value of 0 will be used.  
    Allowed values: `0`, `1`. Example: `1`.
*   `personalized` (query, string)
    
    Controls whether personalization is applied to the response. Set to `none` to opt out of personalized response handling so the response is safe to cache at the CDN layer.
    
    When set to `none`, the server skips applying personalization to the response.
    
    Setting `personalized=none` is necessary but not sufficient for CDN caching: a response is only cached when the endpoint is also cacheable in the [server-side web-tier cache](https://developer.salesforce.com/docs/commerce/commerce-api/guide/server-side-web-tier-caching.html), subject to its TTLs and invalidation. A call that is uncacheable in the web tier is not cached at the CDN either. See [CDN caching](https://developer.salesforce.com/docs/commerce/commerce-api/guide/cdn-caching.html).
    
      
    Allowed values: `none`. Example: `none`.
[...]
